//
// QPerforce is a gui interface to the perforce revision control
// system. It is based on the qt library, and should be easily portable
// across any platform that has this toolkit available.
// 
// Copyright (C) 2002 Jacob Gladish
// 
// TODO: find legit copyright.
//
#ifndef __BRANCH_SPEC_MENU_H__
#define __BRANCH_SPEC_MENU_H__

#include "BranchSpec.h"
#include "IUpdateable.h"
#include "WidgetID.h"
#include <qpopupmenu.h>

class BranchSpecMenu : public QPopupMenu
{
  Q_OBJECT

public:
	
  BranchSpecMenu( QWidget* parent = 0, const char* name = 0 );
  virtual ~BranchSpecMenu();

  void setListView( BranchSpecTable* view );

public slots:

  void slotNew();
  void slotEditSpec();
  void slotDescribe();	
  void slotDelete();
	
	void slotIntegrateFromSpec();
  void slotViewBranches();

signals:

  void showBranchSpecs( WidgetId id );

private:
    
  struct BranchSpecCache : IUpdateable< Perforce::BranchSpecList > {
    BranchSpecCache();   
    void updateCache();       
  };  

  BranchSpecCache _branchSpecCache;
  BranchSpecTable* _branchSpecTable;

};

#endif 


